<template>
  <div class="container-fluid page-landing" :class="themeClasses">
    <div class="container main-container">
      <div class="main">
        <h1 class="title">{{ $t("landing.title") }}</h1>
        <p class="sub-title">{{ $t("landing.subTitle") }}</p>

        <branch-selector
          ref="deliverSelector"
          :selection="selection"
          :branchOptions="branchOptions"
          :cityOptions="cityOptions"
          :areaOptions="areaOptions"
          @check-scope="checkMatchScope"
        ></branch-selector>
      </div>
    </div>

    <loading-mask v-if="isLoading" />
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions, mapMutations } from "vuex";
import LoadingMask from "@/components/Landing/LoadingMask";
import BranchSelector from "@/components/BranchSelector";
import store from "@/store";

import { getGeoLocation, sleep, preorderAvailable } from "@/utils";

export default {
  async beforeRouteEnter(from, to, next) {
    try {
      await store.dispatch("branch/getBranches");
      await store.dispatch("branch/getAreas");
      setTimeout(async () => {
        await store.dispatch("branch/setBranch");
      }, 0);

      next();
    } catch (err) {
      next();
      // NOTE: handle error below.
    }
  },

  components: {
    BranchSelector,
    LoadingMask
  },

  data() {
    return {
      isLoading: false,
      showButtons: true,
      showDeliverSelector: false,
      action: ""
    };
  },
  computed: {
    ...mapState("branch", {
      selection: "select"
    }),

    ...mapGetters({
      hasLocation: "location/hasLocation",
      geolocation: "location/getLocation",
      branchOptions: "branch/branchOptions",
      cityOptions: "branch/cityOptions",
      areaOptions: "branch/areaOptions"
    }),

    ...mapGetters("theme", ["themeClasses"])
  },
  async mounted() {
    this.isLoading = false;
    if (this.hasLocation) {
      return;
    }
    try {
      this.isLoading = true;
      const { latitude, longitude } = await getGeoLocation();
      this.setLocation({ lat: latitude, lng: longitude });
    } catch (error) {
      console.log(error);
      // NOTE: handle error here.
    }
    this.isLoading = false;
  },
  methods: {
    ...mapMutations("branch", ["updateSelect"]),
    ...mapMutations("branch", { clearSelectorAll: "clear" }),
    ...mapActions({
      setLocation: "location/setLocation",
      getBranches: "branch/getBranches",
      getAreas: "branch/getAreas",
      setBranch: "branch/setBranch",
      checkMatchScope: "branch/checkMatchScope"
    })
  },
  created() {
    this.clearSelectorAll();
  }
};
</script>

<style lang="scss">
// NOTE: handle sticky footer problem due to short content.
#app {
  display: flex;
  min-height: 100vh;
  flex-direction: column;
}

.page-landing {
  flex: 1;
}

html[lang="en"] {
  .main-container {
    min-height: 850px;
    @include media-breakpoint-up(md) {
      min-height: 1050px;
    }
    @include media-breakpoint-up(xl) {
      min-height: auto;
    }
  }
}
</style>

<style lang="scss" scoped>
.page-landing {
  position: relative;
  background: url(/static/images/banner-mobile-01.jpg) center center/cover
    no-repeat;
  padding: 0;

  @include media-breakpoint-up(md) {
    background: url(/static/images/banner-desktop.jpg) right center/cover
      no-repeat;
    padding: 0;
    display: flex;
    flex-direction: column;
    min-height: 750px;
  }

  &.theme-vip-member {
    &:before,
    &:after {
      content: "";
      background-image: url("/static/images/ic-gold-frame.png");
      background-size: 200px 6px;
      height: 6px;
      position: absolute;
      left: 0;
      width: 100%;
      z-index: 0;
    }

    &:before {
      top: 0;
    }

    &:after {
      bottom: 0;
    }
  }
}

.main-container {
  min-height: 700px;
  @include media-breakpoint-up(md) {
    position: relative;
    flex: 1;
    min-height: 990px;
  }
  @include media-breakpoint-up(xl) {
    min-height: auto;
  }
}

.main {
  margin: 0 auto;
  padding: 42px 8px 48px 8px;
  width: 100%;
  color: $color-white;

  h1.title {
    margin-bottom: 6px;
    font-size: 33px;
    line-height: 40px;
    text-align: center;
  }

  p.sub-title {
    margin-bottom: 40px;
    font-size: 16px;
    line-height: 1.5;
    text-align: center;
  }

  p.available {
    margin-top: 4px;
    font-size: 12px;
    line-height: 26px;
  }

  .buttonsContainer-enter-active {
    transition: all 0.4s ease-in-out;
  }
  .buttonsContainer-leave-active {
    transition: all 0.4s ease-in-out;
  }
  .buttonsContainer-enter, .buttonsContainer-leave-to
  /* .slide-fade-leave-active for below version 2.1.8 */ {
    transform: translateY(70px);
    opacity: 0;
  }

  .deliverSelectorContainer-enter-active {
    transition: all 0.4s ease-in-out;
  }
  .deliverSelectorContainer-leave-active {
    transition: all 0.4s ease-in-out;
  }
  .deliverSelectorContainer-enter, .deliverSelectorContainer-leave-to
  /* .slide-fade-leave-active for below version 2.1.8 */ {
    transform: translateY(70px);
    opacity: 0;
  }

  div.branch-selector-wrap {
    width: calc(100% - 10px);
    height: 0px;
    margin: 0 6px;
  }
  div.buttons-container {
    width: 100%;
    height: 0px;
    justify-content: center;
  }

  div.branch-selector-wrap,
  div.buttons-container {
    display: inline-flex;
    flex-direction: row;

    div.btn {
      padding: 0px;
      width: 120px;
      height: 120px;
      border-radius: 2px;
      box-shadow: 0 4px 12px 0 rgba(0, 0, 0, 0.5);
      background-color: $color-white;
      color: $color-primary-black;
      margin-right: 20px;
      &:last-child {
        margin-right: 0px;
      }

      &.clickable {
        cursor: pointer;
        &:hover {
          background-color: $color-skm-red;
          color: $color-white;
          .theme-vip-member & {
            background-color: $color-vip-black;
            color: $color-skm-gold;
          }
        }
      }
      &.actived {
        background-color: $color-skm-red;
        color: $color-white;
        display: none;
        .theme-vip-member & {
          background-color: $color-vip-black;
          color: $color-skm-gold;
        }
      }

      &:before {
        position: absolute;
        display: block;
        margin-top: 20px;
        margin-left: 36px;
        content: "";
        width: 48px;
        height: 48px;
        background-image: url("/static/images/landing-page-button.svg");
        background-repeat: no-repeat;
        background-size: 144px 240px;
      }

      &.btn-booking {
        &:before {
          background-position: 0 -48px;
          .theme-vip-member & {
            background-position-y: -192px;
          }
        }
        &.clickable:hover,
        &.actived {
          &:before {
            background-position-y: -144px;
            .theme-vip-member & {
              background-position-y: -192px;
            }
          }
        }
      }
      &.btn-preordering {
        &:before {
          background-position: -48px -48px;
          .theme-vip-member & {
            background-position-y: -192px;
          }
        }
        &.clickable:hover,
        &.actived {
          &:before {
            background-position-y: -144px;
            .theme-vip-member & {
              background-position-y: -192px;
            }
          }
        }
      }

      div.label {
        position: relative;
        top: 78px;
        margin: 0px;
        font-size: 14px;
      }
    }
  }

  @include media-breakpoint-up(md) {
    position: absolute;
    top: 50%;
    left: 0;
    transform: translate(0, -50%);
    z-index: 1;

    max-width: none;
    height: 440px;
    padding: 80px 60px;

    h1.title {
      margin-bottom: 20px;
      font-size: 40px;
      line-height: 1.4;
      text-align: left;
    }

    p.sub-title {
      margin-bottom: 92px;
      font-size: 18px;
      line-height: 1.44;
      text-align: left;
    }

    p.available {
      margin-top: 10px;
    }

    div.buttons-container {
      justify-content: flex-start;
    }

    div.buttons-container {
      div.btn {
        flex-grow: 0;
        flex-shrink: 0;
        width: 140px;
        height: 140px;

        &.actived {
          display: block;
        }

        &:before {
          margin-left: 38px;
          width: 64px;
          height: 64px;
          background-size: 192px 320px;
        }

        &.btn-booking {
          &:before {
            background-position: 0 -64px;
            .theme-vip-member & {
              background-position-y: -256px;
            }
          }
          &.clickable:hover,
          &.actived {
            &:before {
              background-position-y: -192px;
              .theme-vip-member & {
                background-position-y: -256px;
              }
            }
          }
        }
        &.btn-preordering {
          &:before {
            background-position: -64px -64px;
            .theme-vip-member & {
              background-position-y: -256px;
            }
          }
          &.clickable:hover,
          &.actived {
            &:before {
              background-position-y: -192px;
              .theme-vip-member & {
                background-position-y: -256px;
              }
            }
          }
        }

        div.label {
          top: 94px;
          font-size: 16px;
        }
      }
    }
  }
}
</style>
